// tv16 autogear
// 05.12.2017
// by Sergi
#include <stm32f0xx.h>
#include "ILI9325lib.h"
#include <stdlib.h>
#include <string.h>

volatile unsigned char Dsec_fl = 0,spin_dir,w_fl = 0,tread_en_fl = 0,dir;
volatile int32_t step_tmp = 0,step_read,step_save,w = 0,angle = 0,feed_count = 0,err = 0,feed,feed_h,feed_l;
int lim_l=0,lim_r=0,lim_l_en = 0,lim_r_en = 0,lim_l_s = 0,lim_r_s = 0,lim_l_a = 0,lim_r_a = 0;
int spin_enc = 0,man_enc = 0,man_enc_max = 5,man_enc_s,enc_min = 0,man_feed = 50,auto_feed = 20,metr_feed = 125,imp_feed = 14;
const int man_feed_max = 400,man_feed_min = 1,auto_feed_max = 400,auto_feed_min = 1,metr_feed_max = 400,metr_feed_min = 1,imp_feed_max = 40-9,imp_feed_min = 10;
unsigned char key = 0,key_feed,key_fl = 1,man_enc_sw,rvs = 0,man_step_en = 0,auto_step_en = 0,menu = 0,ptr = 6;
char txt[16];
#define step_h GPIOA->BSRR = GPIO_BSRR_BS_11
#define step_l GPIOA->BSRR = GPIO_BSRR_BR_11
#define dir_h  GPIOA->BSRR = GPIO_BSRR_BS_12
#define dir_l  GPIOA->BSRR = GPIO_BSRR_BR_12
#define en_h	 GPIOB->BSRR = GPIO_BSRR_BS_0
#define en_l	 GPIOB->BSRR = GPIO_BSRR_BR_0
#define MaxTreadSpeed 300
#define enc_max	4800
void SysTick_Handler(void)
	{
		int st_tmp;
		Dsec_fl = 1;
		st_tmp = TIM3->CNT;
		step_read = step_tmp;step_tmp = 0;
		if (spin_dir) 
			{
				step_read = step_read + step_save - st_tmp;
			} else {
				step_read = step_read + st_tmp - step_save;
			};
		step_save = st_tmp;
		if (step_read >= 0) w = step_read>>3; else w = 0;
		if (w > 60) w_fl = 1;
		if (w < 50) w_fl = 0;
			/*
		if (++Dsec > 9) Dsec = 0,Sec_fl = 1;
		if(Sec_fl) 
		{
		if (++Sec > 59) Sec = 0,Min_fl = 1;
		};
			*/
	};

void init_gpio(void)
	{
		RCC->AHBENR|=RCC_AHBENR_GPIOAEN;
		RCC->AHBENR|=RCC_AHBENR_GPIOBEN;
		
		GPIOA->MODER &=~  GPIO_MODER_MODER0;		//KEY0
		GPIOA->MODER &=~  GPIO_MODER_MODER1;		//Key1
		GPIOA->MODER &=~  GPIO_MODER_MODER2;		//Key2
		GPIOA->MODER &=~  GPIO_MODER_MODER3;		//Key3
		GPIOA->MODER &=~  GPIO_MODER_MODER4;		//Key4
		GPIOA->MODER &=~  GPIO_MODER_MODER5;		//Key5
		GPIOA->MODER &=~  GPIO_MODER_MODER10;		//Enc_Key
		
		GPIOA->MODER &=~  GPIO_MODER_MODER6;		
		GPIOA->MODER |= GPIO_MODER_MODER6_1;		// spindel enc tim3_1
		GPIOA->AFR[0] |= 0x01000000;	
		GPIOA->MODER &=~  GPIO_MODER_MODER7;		
		GPIOA->MODER |= GPIO_MODER_MODER7_1;		// spindel enc tim3_2
		GPIOA->AFR[0] |= 0x10000000;
		
		GPIOA->MODER &=~  GPIO_MODER_MODER8;		
		GPIOA->MODER |= GPIO_MODER_MODER8_1;		// spindel enc tim1_1
		GPIOA->AFR[1] |= 0x00000002;	
		GPIOA->MODER &=~  GPIO_MODER_MODER9;		
		GPIOA->MODER |= GPIO_MODER_MODER9_1;		// spindel enc tim1_2
		GPIOA->AFR[1] |= 0x00000020;
		
		GPIOA->MODER &=~  GPIO_MODER_MODER11;		
		GPIOA->MODER |= GPIO_MODER_MODER11_0;			// STEP
		GPIOA->OTYPER &=~ GPIO_OTYPER_OT_11;			
		GPIOA->OSPEEDR |= GPIO_OSPEEDER_OSPEEDR11;  
		GPIOA->BSRR |= GPIO_BSRR_BS_11;
		
		GPIOA->MODER &=~  GPIO_MODER_MODER12;		
		GPIOA->MODER |= GPIO_MODER_MODER12_0;			// DIR
		GPIOA->OTYPER &=~ GPIO_OTYPER_OT_12;			
		GPIOA->OSPEEDR |= GPIO_OSPEEDER_OSPEEDR12;  
		GPIOA->BSRR |= GPIO_BSRR_BS_12;
		
		GPIOB->MODER &=~  GPIO_MODER_MODER0;		
		GPIOB->MODER |= GPIO_MODER_MODER0_0;		// EN
		GPIOB->OTYPER &=~ GPIO_OTYPER_OT_0;			
		GPIOB->OSPEEDR |= GPIO_OSPEEDER_OSPEEDR0;  
		GPIOB->BSRR |= GPIO_BSRR_BR_0;	
		
		GPIOB->MODER &=~  GPIO_MODER_MODER1;		
		GPIOB->MODER |= GPIO_MODER_MODER1_1;		// speed tim14
		
		GPIOB->MODER &=~  GPIO_MODER_MODER6;		
		GPIOB->MODER |= GPIO_MODER_MODER6_0;		// buzz 
		GPIOB->OTYPER &=~ GPIO_OTYPER_OT_6;				
		GPIOB->BSRR |= GPIO_BSRR_BR_6;
	};
void init_man_enc(void)
{
	RCC->APB2ENR |= RCC_APB2ENR_TIM1EN;
	TIM1->PSC = 0;							  
	TIM1->ARR = man_enc_max<<2;					  
	TIM1->CNT = 0;
	TIM1->SMCR |= TIM_SMCR_SMS_0 | TIM_SMCR_SMS_1;
	TIM1->CCMR1 |= TIM_CCMR1_IC1PSC_1 | TIM_CCMR1_IC2F_3 | TIM_CCMR1_CC2S_0 | TIM_CCMR1_IC2PSC_1 | TIM_CCMR1_IC1F_3 | TIM_CCMR1_CC1S_0;
	TIM1->CR1 |= TIM_CR1_UDIS	| TIM_CR1_CEN;	
};

void init_spin_enc(void)
{
	RCC->APB1ENR |= RCC_APB1ENR_TIM3EN;
	TIM3->PSC = 0;							  
	TIM3->ARR = 40;					  
	TIM3->CNT = 0;
	TIM3->CCR3 = 8;
	TIM3->SMCR |= TIM_SMCR_SMS_0 | TIM_SMCR_SMS_1;
	TIM3->CCMR1 |= TIM_CCMR1_IC2F_1 | TIM_CCMR1_CC2S_0 | TIM_CCMR1_IC1F_1 | TIM_CCMR1_CC1S_0;
	TIM3->DIER |= TIM_DIER_UIE | TIM_DIER_CC3IE;
	TIM3->CR1 |= TIM_CR1_URS	| TIM_CR1_CEN;
	NVIC_EnableIRQ(TIM3_IRQn);
};

void TIM3_IRQHandler (void)
{
	int tp;
	spin_dir = (TIM3->CR1 & TIM_CR1_DIR)>>4;
	if(spin_dir) 
		{
		if(rvs) dir_h,dir = 1; else dir_l,dir = 0;
		} else {
		if(rvs) dir_l,dir = 0; else dir_h,dir = 1;
		};
	if((dir && !lim_l_a) || (!dir && !lim_r_a))
	{	
	if (auto_step_en)
		{			
		en_l;
		if (TIM3->SR & TIM_SR_UIF)
		{
			step_h;
			if (rvs ^ spin_dir) feed_count--; else feed_count++;
		};
		if (TIM3->SR & TIM_SR_CC3IF) 
		{
			step_l;
			if(err >= feed) tp = 1,err = err-feed;else tp = 0;
			err = err + feed_l;
			TIM3->ARR = feed_h + tp - 1;
		};
		};
	step_tmp+=TIM3->ARR;
	};
	TIM3->SR &=~(TIM_SR_UIF | TIM_SR_CC3IF);
	
};

void init_tim17 (void)
{
	RCC->APB2ENR |= RCC_APB2ENR_TIM17EN;      
	TIM17->CR1 |= TIM_CR1_ARPE;
	TIM17->PSC = 1625-1;			
	TIM17->ARR = 400-1;		//tim17 generate 100 Hz 1mm per sec
	TIM17->CCR1 = 10;
	TIM17->BDTR |= TIM_BDTR_MOE;
	TIM17->DIER |= TIM_DIER_UIE| TIM_DIER_CC1IE;
	TIM17->CR1 |= TIM_CR1_URS;
	//TIM17->CR1 |= TIM_CR1_CEN;
	NVIC_EnableIRQ(TIM17_IRQn);
};

void TIM17_IRQHandler (void)
{
	if(rvs) dir_h; else dir_l;
	if((rvs && !lim_l_a) || (!rvs && !lim_r_a))
	{
	if(man_step_en)
	{
	en_l;
		if (TIM17->SR & TIM_SR_UIF) 
		{
			step_h;
			if (rvs) feed_count++; else feed_count--;
		};
		if (TIM17->SR & TIM_SR_CC1IF) step_l;
	};
	};
	TIM17->SR &=~(TIM_SR_UIF | TIM_SR_CC1IF);
};
void beep (int time)
{
	time = time>>1;
	while(time){
	if(GPIOB->ODR & 0x40) GPIOB->BSRR = GPIO_BSRR_BR_6,delay_us(1000);
	else GPIOB->BSRR = GPIO_BSRR_BS_6,delay_us(1000);
		time--;
	};
	GPIOB->BSRR |= GPIO_BSRR_BR_6;
};

int main (void)
{
	RCC->CR |= RCC_CR_HSEON;
	while (!(RCC->CR & RCC_CR_HSERDY)) {};
	FLASH->ACR |= FLASH_ACR_PRFTBE;
	FLASH->ACR |= FLASH_ACR_LATENCY;	
	RCC->CFGR |= RCC_CFGR_PLLSRC_HSE_PREDIV;
	RCC->CFGR |= RCC_CFGR_PLLXTPRE;
	RCC->CFGR2 = (4-1);								// 	26/4
	RCC->CFGR |= (10-2)<<18; 					/// Xtall/4*10=65
	RCC->CR |= RCC_CR_PLLON;
	while (!(RCC->CR & RCC_CR_PLLRDY)) {}; 
	RCC->CFGR |= RCC_CFGR_SW_PLL;
	RCC->CFGR |= RCC_CFGR_HPRE_DIV1;    
	RCC->CFGR |= RCC_CFGR_PPRE_DIV1;
	RCC->APB2ENR |= RCC_APB2ENR_SYSCFGEN;
	init_gpio();	
	SysTick_Config(6500000); // 6500000  .1sek	
	init_lcd();fill_lcd(Black);
	init_man_enc();init_spin_enc();
	init_tim17();//init_tim16();
	put_string(106,100,"  ",Cyan,Black,1);
	put_string(232,120,"/",White,Black,1);
	put_string(232,140,"/",White,Black,1);
	put_string(290,180,"",White,Black,1);
	put_string(290,220,"",White,Black,1);
	put_string(118,80,".",Orange,Black,2);put_string(230,80," ",Orange,Black,2);
	TIM1->ARR = 2 + (man_enc_max<<2);		
	while(1)
	{
		if(Dsec_fl)
		{
			Dsec_fl = 0;
			key_feed = (~GPIOA->IDR & 0x07);
			key = (~GPIOA->IDR & 0x38)>>3;man_enc_sw = (~GPIOA->IDR & 0x400)>>10;man_enc = TIM1->CNT>>2;
			if (key || man_enc_sw || (man_enc != man_enc_s)) beep(20),key_fl = 1;man_enc_s = man_enc;	
			if (TIM3->ARR == enc_max) angle = TIM3->CNT * 75; else angle = 0;	
			if(!lim_l_en) 
			{
				put_string(62,100,".",Cyan,Black,1);
				if (lim_l < 0) put_string(6,100,"-",Cyan,Black,1),itoa (-lim_l/100,txt);
				else put_string(6,100," ",Cyan,Black,1),itoa (lim_l/100,txt);
			if (strlen(txt) > 2) put_string(20,100,txt,Cyan,Black,1); else
				if (strlen(txt) > 1) put_string(34,100,txt,Cyan,Black,1),put_string(20,100," ",Cyan,Black,1);else
					put_string(48,100,txt,Cyan,Black,1),put_string(20,100,"  ",Cyan,Black,1);
			if (lim_l < 0) itoa (-lim_l%100,txt);	else itoa (lim_l%100,txt);	
			if (strlen(txt) == 2) put_string(76,100,txt,Cyan,Black,1); 
				else put_string(76,100,"0",Cyan,Black,1),put_string(90,100,txt,Cyan,Black,1);
			} else {
			if (!lim_l_a)
				{
					put_string(62,100,".",Green,Black,1);
				if (lim_l < 0) put_string(6,100,"-",Green,Black,1),itoa (-lim_l/100,txt);
					else put_string(6,100," ",Green,Black,1),itoa (lim_l/100,txt);
						if (strlen(txt) > 2) put_string(20,100,txt,Green,Black,1); else
				if (strlen(txt) > 1) put_string(34,100,txt,Green,Black,1),put_string(20,100," ",Green,Black,1);else
					put_string(48,100,txt,Green,Black,1),put_string(20,100,"  ",Green,Black,1);
				if (lim_l < 0) itoa (-lim_l%100,txt);	else itoa (lim_l%100,txt);	
					if (strlen(txt) == 2) put_string(76,100,txt,Green,Black,1); 
						else put_string(76,100,"0",Green,Black,1),put_string(90,100,txt,Green,Black,1);
				} else {
					put_string(62,100,".",Green,Red,1);
				if (lim_l < 0) put_string(6,100,"-",Green,Red,1),itoa (-lim_l/100,txt);
					else put_string(6,100," ",Green,Red,1),itoa (lim_l/100,txt);
						if (strlen(txt) > 2) put_string(20,100,txt,Green,Red,1); else
				if (strlen(txt) > 1) put_string(34,100,txt,Green,Red,1),put_string(20,100," ",Green,Red,1);else
					put_string(48,100,txt,Green,Red,1),put_string(20,100,"  ",Green,Red,1);
				if (lim_l < 0) itoa (-lim_l%100,txt);	else itoa (lim_l%100,txt);	
					if (strlen(txt) == 2) put_string(76,100,txt,Green,Red,1); 
						else put_string(76,100,"0",Green,Red,1),put_string(90,100,txt,Green,Red,1);
				};				
			};
			if(!lim_r_en) 
			{
				put_string(276,100,".",Cyan,Black,1);
				if (lim_r < 0) put_string(220,100,"-",Cyan,Black,1),itoa (-lim_r/100,txt);
				else put_string(220,100," ",Cyan,Black,1),itoa (lim_r/100,txt);
			if (strlen(txt) > 2) put_string(234,100,txt,Cyan,Black,1); else
				if (strlen(txt) > 1) put_string(248,100,txt,Cyan,Black,1),put_string(234,100," ",Cyan,Black,1);else
					put_string(262,100,txt,Cyan,Black,1),put_string(234,100,"  ",Cyan,Black,1);
			if (lim_r < 0) itoa (-lim_r%100,txt);	else itoa (lim_r%100,txt);	
			if (strlen(txt) == 2) put_string(290,100,txt,Cyan,Black,1); 
				else put_string(290,100,"0",Cyan,Black,1),put_string(304,100,txt,Cyan,Black,1);
			} else {
			if (!lim_r_a)
				{
					put_string(276,100,".",Green,Black,1);
				if (lim_r < 0) put_string(220,100,"-",Green,Black,1),itoa (-lim_r/100,txt);
					else put_string(220,100," ",Green,Black,1),itoa (lim_r/100,txt);
						if (strlen(txt) > 2) put_string(234,100,txt,Green,Black,1); else
				if (strlen(txt) > 1) put_string(248,100,txt,Green,Black,1),put_string(234,100," ",Green,Black,1);else
					put_string(262,100,txt,Green,Black,1),put_string(234,100,"  ",Green,Black,1);
				if (lim_r < 0) itoa (-lim_r%100,txt);	else itoa (lim_r%100,txt);	
					if (strlen(txt) == 2) put_string(290,100,txt,Green,Black,1); 
						else put_string(290,100,"0",Green,Black,1),put_string(304,100,txt,Green,Black,1);
				} else {
					put_string(276,100,".",Green,Red,1);
				if (lim_r < 0) put_string(220,100,"-",Green,Red,1),itoa (-lim_r/100,txt);
					else put_string(220,100," ",Green,Red,1),itoa (lim_r/100,txt);
						if (strlen(txt) > 2) put_string(234,100,txt,Green,Red,1); else
				if (strlen(txt) > 1) put_string(248,100,txt,Green,Red,1),put_string(234,100," ",Green,Red,1);else
					put_string(262,100,txt,Green,Red,1),put_string(234,100,"  ",Green,Red,1);
				if (lim_r < 0) itoa (-lim_r%100,txt);	else itoa (lim_r%100,txt);	
					if (strlen(txt) == 2) put_string(290,100,txt,Green,Red,1); 
						else put_string(290,100,"0",Green,Red,1),put_string(304,100,txt,Green,Red,1);
				};				
			};
			
			if(key_fl) {
			if(man_enc_sw){
				switch (menu){
					case 6: { menu = ptr,TIM1->CNT = (ptr<<2),TIM1->ARR = 22,enc_min =0,ptr = 6;}; break;
					case 0: { menu = 6,TIM1->ARR = (man_feed_max<<2)-1,enc_min = man_feed_min,TIM1->CNT = (man_feed-enc_min)<<2,ptr = 0;};break;
					case 1: { menu = 6,TIM1->ARR = (auto_feed_max<<2)-1,enc_min = auto_feed_min,TIM1->CNT = (auto_feed-enc_min)<<2,ptr = 1;};break;
					case 2: { menu = 6,TIM1->ARR = (metr_feed_max<<2)-1,enc_min = metr_feed_min,TIM1->CNT = (metr_feed-enc_min)<<2,ptr = 2;};break;
					case 3: { menu = 6,TIM1->ARR = (metr_feed_max<<2)-1,enc_min = metr_feed_min,TIM1->CNT = (metr_feed-enc_min)<<2,ptr = 3;};break;
					case 4: { menu = 6,TIM1->ARR = (imp_feed_max<<2)-1,enc_min = imp_feed_min,TIM1->CNT = (imp_feed-enc_min)<<2,ptr = 4;};break;
					case 5: { menu = 6,TIM1->ARR = (imp_feed_max<<2)-1,enc_min = imp_feed_min,TIM1->CNT = (imp_feed-enc_min)<<2,ptr = 5;};break;
					};
					beep(1000);	man_enc_sw = 0;
			};
			man_enc = (TIM1->CNT>>2) + enc_min;		
			if(menu < 6)  menu = man_enc;	
			if(menu == 0) put_string(0,120," ",Black,White,1);else put_string(0,120," ",White,Black,1);
			if(menu == 1) put_string(0,140," ",Black,White,1);else put_string(0,140," ",White,Black,1);
			if(menu == 2) put_string(0,160," ",Black,White,1),rvs = 0;else put_string(0,160," ",White,Black,1);
			if(menu == 3) put_string(0,180,"  ",Black,White,1),rvs = 1;else put_string(0,180,"  ",White,Black,1);
			if(menu == 4) put_string(0,200," ",Black,White,1),rvs = 0;else put_string(0,200," ",White,Black,1);
			if(menu == 5) put_string(0,220,"  ",Black,White,1),rvs = 1;else put_string(0,220,"  ",White,Black,1);			
			if(ptr == 0) 
				{
					man_feed = man_enc;
					put_string(190,120,".",Black,Magenta,1);
					itoa(man_feed/100,txt),put_string(176,120,txt,Black,Magenta,1);
					itoa(man_feed%100,txt);
					if (strlen(txt) == 2) put_string(204,120,txt,Black,Magenta,1); else
						put_string(204,120,"0",Black,Magenta,1),put_string(218,120,txt,Black,Magenta,1);
				} else {
					put_string(190,120,".",Magenta,Black,1);
					itoa(man_feed/100,txt),put_string(176,120,txt,Magenta,Black,1);
					itoa(man_feed%100,txt);
					if (strlen(txt) == 2) put_string(204,120,txt,Magenta,Black,1); else
						put_string(204,120,"0",Magenta,Black,1),put_string(218,120,txt,Magenta,Black,1);
				};
			if(ptr == 1) 
				{
					auto_feed = man_enc;
					put_string(190,140,".",Black,Green,1);
					itoa(auto_feed/100,txt),put_string(176,140,txt,Black,Green,1);
					itoa(auto_feed%100,txt);
					if (strlen(txt) == 2) put_string(204,140,txt,Black,Green,1); else
						put_string(204,140,"0",Black,Green,1),put_string(218,140,txt,Black,Green,1);
				} else {
					put_string(190,140,".",Green,Black,1);
					itoa(auto_feed/100,txt),put_string(176,140,txt,Green,Black,1);
					itoa(auto_feed%100,txt);
					if (strlen(txt) == 2) put_string(204,140,txt,Green,Black,1); else
						put_string(204,140,"0",Green,Black,1),put_string(218,140,txt,Green,Black,1);
				};
			if((ptr == 2) || (ptr == 3))
				{
					metr_feed = man_enc;
					put_string(204,180,".",Black,Orchid,2);
					itoa(metr_feed/100,txt),put_string(176,180,txt,Black,Orchid,2);
					itoa(metr_feed%100,txt);
					if (strlen(txt) == 2) put_string(232,180,txt,Black,Orchid,2); else
						put_string(232,180,"0",Black,Orchid,2),put_string(260,180,txt,Black,Orchid,2);
				} else {
					put_string(204,180,".",Orchid,Black,2);
					itoa(metr_feed/100,txt),put_string(176,180,txt,Orchid,Black,2);
					itoa(metr_feed%100,txt);
					if (strlen(txt) == 2) put_string(232,180,txt,Orchid,Black,2); else
						put_string(232,180,"0",Orchid,Black,2),put_string(260,180,txt,Orchid,Black,2);
				};
			if((ptr == 4) || (ptr == 5))
				{
					imp_feed = man_enc;
					if(man_enc_sw)  menu = 0,TIM1->CNT = 2,TIM1->ARR = 20,ptr = 6;
					itoa(imp_feed,txt);
					if (strlen(txt) == 2) put_string(232,220,txt,Black,Blue,2); else
						put_string(232,220," ",Black,Blue,2),put_string(260,220,txt,Black,Blue,2);
				} else {
					itoa(imp_feed,txt);
					if (strlen(txt) == 2) put_string(232,220,txt,Blue,Black,2); else
						put_string(232,220," ",Blue,Black,2),put_string(260,220,txt,Blue,Black,2);
				};
			if(key == 1)
			{ if(lim_r_en) lim_r_en = 0; else lim_r_en = 1,lim_r = feed_count;
				lim_r_s = lim_r_en;
				beep(1000);};
			if(key == 4)
			{	if(lim_l_en) lim_l_en = 0; else lim_l_en = 1,lim_l = feed_count;
				lim_l_s = lim_l_en;
				beep(1000);};
			if(key == 2)
			{ feed_count = 0,TIM3->CNT = 0,lim_r_en = 0, lim_l_en = 0,lim_r = 0,lim_l = 0;
				lim_l_s = lim_l_en;lim_r_s = lim_r_en;
				beep(1000);};
			key_fl = 0;
			};
			if((menu > 1) && (menu < 6))
			{
				man_step_en = 0;
				if((w == 0) && (!tread_en_fl)) 
				{
					lim_l_s = lim_l_en;lim_r_s = lim_r_en;
					tread_en_fl = 1,lim_r_en = 0, lim_l_en = 0;		
				};
				if(tread_en_fl && (w <= MaxTreadSpeed))
				{
				auto_step_en = 1;
				lcd_fill_rec(00,221,319,239,Green);put_string(125,241,"",Black,Green,1);//
				if(menu == 2) rvs = 0,feed = metr_feed;				
				if(menu == 3) rvs = 1,feed = metr_feed;
				if((menu == 4) && (imp_feed)) rvs = 0,feed = 2545/imp_feed;
				if((menu == 5) && (imp_feed)) rvs = 1,feed = 2545/imp_feed;
				if(feed > 400) feed = 400; else if(feed == 0) feed = 1;
				feed_h = enc_max/feed,feed_l = enc_max%feed;
				} else 
				lcd_fill_rec(00,221,319,239,Red),put_string(132,240,"",Black,Red,1),auto_step_en = 0,en_h;
			} else {
			lcd_fill_rec(0,221,319,239,Black),
				tread_en_fl = 0,auto_step_en = 0,en_h;
			lim_l_en = lim_l_s;lim_r_en = lim_r_s;
			if (menu == 0) TIM3->ARR = enc_max;
			if(key_feed)
			{
				if((menu == 0) && (man_feed)) {
				auto_step_en = 0;
				switch (key_feed) {		
				case 1: rvs = 0,TIM17->ARR = 40000/man_feed-1;break;
				case 2: rvs = 1,TIM17->ARR = 40000/man_feed-1; break;
				case 5: rvs = 0,TIM17->ARR = 5000/man_feed-1;break;
				case 6: rvs = 1,TIM17->ARR = 5000/man_feed-1;break;
				};
				if((key_feed == 1) || (key_feed == 2) || (key_feed == 5) || (key_feed == 6)) TIM17->CR1 |= TIM_CR1_CEN,man_step_en = 1;
				}	else man_step_en = 0,en_h,TIM17->CR1 &=~ TIM_CR1_CEN;
				
				if(menu == 1) {
				man_step_en = 0;
				switch (key_feed) {		
				case 1: rvs = 0,feed = auto_feed;break;
				case 2: rvs = 1,feed = auto_feed;break;
				case 5: rvs = 0,feed = auto_feed<<3;break;
				case 6: rvs = 1,feed = auto_feed<<3;break;
				};
				if(feed > 400) feed = 400; else if(feed == 0) feed = 1;
				feed_h = enc_max/feed,feed_l = enc_max%feed;
				if((key_feed == 1) || (key_feed == 2) || (key_feed == 5) || (key_feed == 6)) auto_step_en = 1;
				} else auto_step_en = 0,en_h;
			} else man_step_en = 0,auto_step_en = 0,en_h;
		};	
		};	
		if (w_fl) //degree or rpm one string
			{			
				itoa (w,txt);	put_string(118,40,"/ ",Yellow,Black,2);
				if (strlen(txt) > 3) put_string(6,40,txt,Yellow,Black,2); else
				if (strlen(txt) > 2) put_string(34,40,txt,Yellow,Black,2),lcd_fill_rec(6,0,33,40,Black);
							else put_string(62,40,txt,Yellow,Black,2),lcd_fill_rec(6,0,61,40,Black);
			} else {
				put_string(90,40,".",Yellow,Black,2);put_string(202,40,"",Yellow,Black,2);
				itoa (angle/1000,txt);
				if (strlen(txt) > 2) put_string(6,40,txt,Yellow,Black,2);
				else if (strlen(txt) > 1) put_string(34,40,txt,Yellow,Black,2),lcd_fill_rec(6,0,33,40,Black);
							else put_string(62,40,txt,Yellow,Black,2),lcd_fill_rec(6,0,61,40,Black);
				itoa (angle%1000,txt);put_string(118,40,txt,Yellow,Black,2);
				if (strlen(txt) == 1) put_string(146,40,"00",Yellow,Black,2); 
					else if (strlen(txt) == 2) put_string(174,40,"0",Yellow,Black,2);
			};
			
				//feed_count
			if (feed_count < 0) put_string(6,80,"-",Orange,Black,2),itoa (-feed_count/100,txt);
				else put_string(6,80," ",Orange,Black,2),itoa (feed_count/100,txt);
			if (strlen(txt) > 2) put_string(34,80,txt,Orange,Black,2); else
				if (strlen(txt) > 1) put_string(62,80,txt,Orange,Black,2),lcd_fill_rec(34,40,63,80,Black);else
					put_string(90,80,txt,Orange,Black,2),lcd_fill_rec(34,40,89,80,Black);
			if (feed_count < 0) itoa (-feed_count%100,txt);	else itoa (feed_count%100,txt);	
			if (strlen(txt) == 2) put_string(146,80,txt,Orange,Black,2); 
				else put_string(146,80,"0",Orange,Black,2),put_string(174,80,txt,Orange,Black,2);
		if(lim_l_en)
		{
			if(feed_count >= lim_l)  lim_l_a = 1; else lim_l_a = 0;
		} else lim_l_a = 0;
		if(lim_r_en)
		{
			if(feed_count <= lim_r)  lim_r_a = 1; else lim_r_a = 0;
		} else lim_r_a = 0;
	};
};
